/*
 *  Licensed Materials - Property of IBM
 *  5725-G92 (C) Copyright IBM Corp. 2011, 2012. All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

define({ root:

({
    //  START NON-TRANSLATABLE
	settingsServerurlPlaceHolderText: "name[:port][/path]",
	defaultRootContext: "applicationcenter"	,
    //  END NON-TRANSLATABLE	
	
	//******************** 
	// General purpose resources
	Back: "~@Back~1",
	Yes: "~@Yes~2",
	No: "~@No~3",
	
	
	//******************** 
	// Misc, Warning and Error messages
	loadingMessage: "~@loading ...~4",
	loadAppVersionsMessage: "~@loading application versions ...~5",
	noConnectionMessage: "~@No connection~6",
	clickToRefreshMessage: "~@Click to Refresh~7",
	cancelTryMessage: "~@Trying to cancel...\nIt might take upto 5 minutes before you can reinstall %1~8",
	installationFailedError: "~@Failed to install %1~9",
	feedbackSuccessMessage: "~@Feedback successfully sent!~10",
	serverConnectionFailedError: "~@Failed to connect to the server~11",
	feedbackFailedError: "~@Failed to send feedback~12",
	
	
	//******************** 
	// Resources for main view 	
	headingTitleSpanText: "~@Applications~13", // note to dev: this is a <span>, i18n is done programatically
	
	
	//******************** 
	// Resources for the tab bar
	myMobileTabLabel: "~@My Mobile~14",
	catalogTabLabel: "~@Catalog~15",
	inProgressTabLabel: "~@In Progress~16",
	settingsTabLabel: "~@Settings~17",
	
	
	//******************** 
	// Resources for the "My Mobile" view: 
	// This view displays the list of installed application
	myMobileViewHeaderText: "~@Applications~18",
	myMobileViewCategory1Text: "~@Installed~19",
	myMobileViewCategory2Text: "~@Update or Mandatory~20",
	myMobileViewMsg1: "~@No installations detected~21",
	myMobileViewMsg2: "~@No Updates or Mandatory~22", // note to dev: this is a <span>, i18n is done programatically
	myMobileViewMsg3: "~@No Connectivity~23", // note to dev: this is a <span>, i18n is done programatically
		
	
	//******************** 
	// Resources for the "Catalog" view: 
	// This view displays the list of application available on the App Center
	catalogViewHeaderText: "~@Listed Applications~24",
	catalogViewMsg1: "~@No Application to install~25", // note to dev: this is a <span>, i18n is done programatically
	catalogViewMsg2: "~@No Connectivity~26", // note to dev: this is a <span>, i18n is done programatically

		
	//******************** 
	// Resources for the "In Progress" view: 
	// This view displays the list of pending application tasks
	inProgressViewHeaderText: "~@In Progress Applications~27",
	nothingToProgressListItemLabel: "~@Nothing to report~28",
	
	
	//******************** 
	// Resources for the "noAppContentView" view: 
	noAppContentViewHeaderText: "~@Application List Empty~29",
    noAppContentViewMsg1: "~@Application list is empty.~30", 
	
    
	//******************** 
	// Resources for the "app info" view:
    // This view display information about the current selected app whatever the list
    appInfoViewHeaderText: "~@Should be app name~31", // note to dev: this is a <span>, i18n is done programatically
    appInfoPackageText: "~@Package~32",
    appInfoPackageNavText: "~@Package~33",
    appInfoVersionText: "~@Version~34",
    appInfoDescriptionText: "~@Description~35",
    appInfoDescriptionNavText: "~@Description~36",
    appInfoMandatoryText: "~@Mandatory~37",
    appInfoRatingText: "~@Rating and feedback~38",
    progressInfoStatusCategoryText: "~@Progress Information~39", // note to dev: this is a <span>, i18n is done programatically
    progressInfoStatusText: "~@test~40", // note to dev: this is a <span>, i18n is done programatically
    installButtonText: "~@Install Now~41",
    switchButtonText: "~@Switch version...~42",
    removeButtonText: "~@Remove Now~43",
    reportNotInstalledButtonText: "~@Report Not Installed~44",
    cancelButtonText: "~@Cancel Now~45",
    reportNotInProgressButtonText: "~@Report Not in Progress~46",
    
    
	//******************** 
	// Resources for the "textDetailsView" view:
    textDetailsViewHeaderText: "~@Should be app name~47", // note to dev: this is a <span>, i18n is done programatically
    textDetailsCategoryText: "~@test~48", // note to dev: this is a <span>, i18n is done programatically
    textDetailsText: "~@test~49", // note to dev: this is a <span>, i18n is done programatically
    
    
	//******************** 
	// Resources for the "version switching" view:
    versionSwitcherViewHeaderText: "~@Version switching~50", // note to dev: this is a <span>, i18n is done programatically
    versionSwitcherCategory1Text: "~@Installed version~51", // note to dev: this is a <span>, i18n is done programatically
    versionSwitcherCategory2Text: "~@Select a version to switch to~52", // note to dev: this is a <span>, i18n is done programatically
    versionSwitcherSwitchButtonText: "~@Switch Now~53",
    
    
	//******************** 
	// Resources for the "feedback" view:
    feedbackDetailsViewHeaderText: "~@Rating and Feedback~54", //note for dev: this is a <span>, i18n is done programatically
    feedbackDetailsViewLabel1: "~@Tap a star to rate the application~55", // note for dev: this is a <label>, i18n is done programatically
    feedbackDetailsTextAreaPlaceHolderText: "~@What is your feedback?~56",
    feedbackDetailsSubmitButtonLabel: "~@Submit~57",
    
    
	//******************** 
	// Resources for the "settings" view:
    settingsViewHeaderText: "~@Settings~58",
    userIdText: "~@User ID~59", // note to dev: this is a <span>, i18n is done programatically
    settingsUseridPlaceHolderText: "~@Enter your ID~60",
    passwordText: "~@Password~61", // note to dev: this is a <span>, i18n is done programatically
    settingsPasswordPlaceHolder: "~@Enter your password~62",
    serverUrlText: "~@Server URL~63", // note to dev: this is a <span>, i18n is done programatically
    sslText: "~@SSL~64",
    settingsSubmitButtonText: "~@Connect~65",
    

	//******************** 
	// Resources used in Settings.js    
    userIDEmptyError: "~@User ID field cannot be empty~66",
    passowrdEmptyError: "~@Password field cannot be empty~67",
    serverUrlEmptyError: "~@Server URL field cannot be empty~68",
    invalidServerUrlError: "~@Invalid Server URL~69",
    
	//******************** 
	// Resources used in InstallerNative.js        
    initInstallerError: "~@Error initializing Installer: %1~70",
    installApplicationError: "~@Error in installApplication: %1~71",
    removeApplicationError: "~@Error in removeApplication: %1~72",
    cancelApplicationError: "~@Error in cancelApplication: %1~73",
    downloadIconError: "~@Error in downloadIcon: %1~74",
    updateConnectionError: "~@Error in updateConnection: %1~75",
    syncInstalledApplicationsError: "~@Error in syncInstalledApplications: %1~76",   
    
})

,
"fr": true,

});
