/*
 * Licensed Materials - Property of IBM
 * 5725-G92 (C) Copyright IBM Corp. 2011, 2012. All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

#import "IBMAppCenter.h"


@implementation MyAppDelegate

- (NSURL *) getInvokeStringAsURL {
    
    if (_invokeString) {
        return [NSURL URLWithString: _invokeString];
    }
    
    return nil;
}
	
- (id) init
{	
	/*
	* If you need to do any extra app-specific initialization, you can do it here.
	**/
    self = [super init];
    if (self) {
        _invokeString = nil;
    }
    return self;

}

// Implementing this method to save invoking URLs...
- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    
    _invokeString = nil;
    
    // Did we get a URL?
    NSURL *launchURL = (NSURL *)[launchOptions objectForKey: UIApplicationLaunchOptionsURLKey];
    
    if (launchURL) {
        // we got something!!!
        _invokeString = [[launchURL absoluteString] retain];
		NSLog(@" launchOptions = %@", _invokeString); 
    }
    
	// call super, because it is super important ( 99% of phonegap functionality starts here )
	return [super application:application didFinishLaunchingWithOptions:launchOptions];
}

/**
 * This is main kick off after the app inits, the views and Settings are setup here.
 */
- (void)applicationDidFinishLaunching:(UIApplication *)application
{	
	[ super applicationDidFinishLaunching:application ];
}

/**
* These functions handle moving to background and foreground and invoke the appropriate JavaScript functions in the UIWebView.
*/

- (void)applicationDidEnterBackground:(UIApplication *)application
{
	NSString *result = [super.viewController.webView stringByEvaluatingJavaScriptFromString:@"WL.App.BackgroundHandler.onAppEnteringBackground();"]; 
	if([result isEqualToString:@"hideView"]){
		[[self.viewController view] setHidden:YES];
	}
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
	NSString *result = [super.viewController.webView stringByEvaluatingJavaScriptFromString:@"WL.App.BackgroundHandler.onAppEnteringForeground();"];
	if([result isEqualToString:@"hideViewToForeground"]){
		[[self.viewController view] setHidden:NO];
	}
}

- (void)applicationDidBecomeActive:(UIApplication *)application 
{
	[super applicationDidBecomeActive:application];
    /*
     * If you need to do any extra app-specific stuff, you can do it here.
     **/
}

- (void)dealloc
{
    if (_invokeString != nil) {
        [_invokeString release];
        _invokeString = nil;
    }
    
	[super dealloc];
}

@end
