# IBM Worklight Server uninstallation script for WebSphere Application Server.
#
# Licensed Materials - Property of IBM
# 5725-G92 (C) Copyright IBM Corp. 2011, 2012. All Rights Reserved.
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#

import glob
import os
import sys

if len(sys.argv) > 0:
	# Note: On Unix, wsadmin does not accept empty arguments.
	# Arguments that start with a minus sign are dangerous as well.
	# Therefore all arguments are prefixed with '='.

	appserver_selection                      = sys.argv[0] [1:]
	appserver_was_installdir                 = sys.argv[1] [1:]
	appserver_was_profile                    = sys.argv[2] [1:]
	appserver_was_profile_dir                = sys.argv[3] [1:]
	appserver_was_cell                       = sys.argv[4] [1:]
	appserver_was_node                       = sys.argv[5] [1:]
	appserver_was_serverInstance             = sys.argv[6] [1:]
	appserver_was_scope                      = sys.argv[7] [1:]
	appserver_was_admin_name                 = sys.argv[8] [1:]
	appserver_was_admin_password             = sys.argv[9] [1:]
	appserver_was_appcenteradmin_password    = sys.argv[10] [1:]
	database_selection                       = sys.argv[11] [1:]
	database_preinstalled                    = sys.argv[12] [1:]
	database_derby_datadir                   = sys.argv[13] [1:]
	database_db2_host                        = sys.argv[14] [1:]
	database_db2_port                        = sys.argv[15] [1:]
	database_db2_driver                      = sys.argv[16] [1:]
	database_db2_worklight_admin_name        = sys.argv[17] [1:]
	database_db2_worklight_admin_password    = sys.argv[18] [1:]
	database_mysql_host                      = sys.argv[19] [1:]
	database_mysql_port                      = sys.argv[20] [1:]
	database_mysql_driver                    = sys.argv[21] [1:]
	database_mysql_worklight_admin_name      = sys.argv[22] [1:]
	database_mysql_worklight_admin_password  = sys.argv[23] [1:]
	database_oracle_host                     = sys.argv[24] [1:]
	database_oracle_port                     = sys.argv[25] [1:]
	database_oracle_driver                   = sys.argv[26] [1:]
	database_oracle_worklight_admin_name     = sys.argv[27] [1:]
	database_oracle_worklight_admin_password = sys.argv[28] [1:]

	worklight_war                            = sys.argv[29] [1:]
	worklight_war_basename                   = sys.argv[30] [1:]
	worklight_war_context                    = sys.argv[31] [1:]
	worklight_war_appname                    = sys.argv[32] [1:]
	worklight_lib                            = sys.argv[33] [1:]
	worklight_lib_basename                   = sys.argv[34] [1:]

	appcenter_war                            = sys.argv[35] [1:]
	appcenter_war_basename                   = sys.argv[36] [1:]
	appcenter_war_context                    = sys.argv[37] [1:]
	appcenter_war_appname                    = sys.argv[38] [1:]
	derby_lib                                = sys.argv[39] [1:]
	derby_lib_basename                       = sys.argv[40] [1:]

	worklight_database_name                  = sys.argv[41] [1:]
	worklightreports_database_name           = sys.argv[42] [1:]
	appcenter_database_name                  = sys.argv[43] [1:]

	database_worklight_admin_name            = sys.argv[44] [1:]
	database_worklight_admin_password        = sys.argv[45] [1:]

	android_aapt_filename                    = sys.argv[46] [1:]

	database_derby_driverclass               = sys.argv[47] [1:]
	database_db2_uri                         = sys.argv[48] [1:]
	database_db2_driverclass                 = sys.argv[49] [1:]
	database_mysql_uri                       = sys.argv[50] [1:]
	database_mysql_driverclass               = sys.argv[51] [1:]
	database_oracle_uri                      = sys.argv[52] [1:]
	database_oracle_driverclass              = sys.argv[53] [1:]
	database_db2_driver_dir                  = sys.argv[54] [1:]

	worklight_database_schema                = sys.argv[55] [1:]
	worklightreports_database_schema         = sys.argv[56] [1:]
	appcenter_database_schema                = sys.argv[57] [1:]

	worklight_database_jdbc_url              = sys.argv[58] [1:]
	worklightreports_database_jdbc_url       = sys.argv[59] [1:]
	appcenter_database_jdbc_url              = sys.argv[60] [1:]

	worklight_database_jndi_name             = sys.argv[61] [1:]
	worklightreports_database_jndi_name      = sys.argv[62] [1:]
	appcenter_database_jndi_name             = sys.argv[63] [1:]

	appserver_resourcesdir                   = sys.argv[64] [1:]

else:
	# Settings for Bruno's testing.
	appserver_selection = 'was'
	appserver_was_installdir = '/n/java/webservers/was-8.0-express'
	appserver_was_profile = 'AppSrv01'
	appserver_was_profile_dir = '/n/java/webservers/was-8.0-express/profiles/AppSrv01'
	appserver_was_cell = 'bordeauxNode02Cell'
	appserver_was_node = 'bordeauxNode02'
	appserver_was_serverInstance = 'server1'
	appserver_was_scope = 'cell'
	appserver_was_admin_name = 'admin'
	appserver_was_admin_password = 'admin'
	appserver_was_appcenteradmin_password = 'rdeouiruwoir'
	database_selection = 'derby'
	database_preinstalled = 'false'
	database_derby_datadir = '/var/ibm/Worklight/derby'
	database_db2_host = ''
	database_db2_port = ''
	database_db2_driver = ''
	database_db2_worklight_admin_name = ''
	database_db2_worklight_admin_password = ''
	database_mysql_host = ''
	database_mysql_port = ''
	database_mysql_driver = ''
	database_mysql_worklight_admin_name = ''
	database_mysql_worklight_admin_password = ''
	database_oracle_host = ''
	database_oracle_port = ''
	database_oracle_driver = ''
	database_oracle_worklight_admin_name = ''
	database_oracle_worklight_admin_password = ''

	worklight_war = '/n/distrib/wl-mfee-5001-server/WorklightServer/worklight.war'
	worklight_war_basename = 'worklight.war'
	worklight_war_context = '/worklight'
	worklight_war_appname = 'IBM_Worklight_Console'
	worklight_lib = 'worklight-jee-library.jar'
	worklight_lib_basename = 'worklight-jee-library.jar'

	appcenter_war = '/n/distrib/wl-mfee-5001-server/WorklightServer/../ApplicationCenter/console/ibmapplicationcenter.war'
	appcenter_war_basename = 'ibmapplicationcenter.war'
	appcenter_war_context = '/applicationcenter'
	appcenter_war_appname = 'IBM_Application_Center'
	derby_lib = 'install/derby.jar'
	derby_lib_basename = 'derby.jar'

	worklight_database_name = 'WRKLGHT'
	worklightreports_database_name = 'WLREPORT'
	appcenter_database_name = 'MOBILE'

	database_worklight_admin_name = 'foo'
	database_worklight_admin_password = ''

	android_aapt_filename = ''

	database_derby_driverclass = 'org.apache.derby.jdbc.EmbeddedDriver'
	database_db2_uri = ''
	database_db2_driverclass = 'com.ibm.db2.jcc.DB2Driver'
	database_mysql_uri = ''
	database_mysql_driverclass = 'com.mysql.jdbc.Driver'
	database_oracle_uri = ''
	database_oracle_driverclass = 'oracle.jdbc.OracleDriver'
	database_db2_driver_dir = '/n/home/haible/worklight/db2-svt'

	worklight_database_schema = 'WORKLIGHT'
	worklightreports_database_schema = 'WORKLIGHT'
	appcenter_database_schema = 'PUREMEAP'

	worklight_database_jdbc_url = 'jdbc:derby:/var/ibm/Worklight/derby/WRKLGHT'
	worklightreports_database_jdbc_url = 'jdbc:derby:/var/ibm/Worklight/derby/WLREPORT'
	appcenter_database_jdbc_url = 'jdbc:derby:/var/ibm/Worklight/derby/MOBILE'

	worklight_database_jndi_name = 'jdbc/WorklightDS'
	worklightreports_database_jndi_name = 'jdbc/WorklightReportsDS'
	appcenter_database_jndi_name = 'jdbc/Mobile'

	appserver_resourcesdir = '/n/java/webservers/was-8.0-express/optionalLibraries/IBM/Worklight/5.0'

# Jython is Python 2.1 compatible, which did not have the boolean type.
True = 1
False = 0

# Test whether WAS 8.0 or newer is used.
was8 = not glob.glob(appserver_was_installdir + os.sep + 'features' + os.sep + 'com.ibm.ws.osgi.applications_*') == []

# Derived variables.
if appserver_was_scope == 'cell':
	scopeContainmentPath = '/Cell:' + appserver_was_cell + '/'
	scopeParam = 'Cell=' + appserver_was_cell
elif appserver_was_scope == 'node':
	scopeContainmentPath = '/Cell:' + appserver_was_cell + '/Node:' + appserver_was_node + '/'
	scopeParam = 'Node=' + appserver_was_node
else:
	scopeContainmentPath = '/Cell:' + appserver_was_cell + '/Node:' + appserver_was_node + '/Server:' + appserver_was_serverInstance + '/'
	scopeParam = 'Server=' + appserver_was_serverInstance
scopeObject = AdminConfig.getid(scopeContainmentPath)

print 'was-uninstall.py scope setting:'
print scopeContainmentPath
print scopeParam
print scopeObject
print AdminConfig.show(scopeObject)
print

# ======================== Stop the web applications ========================

# Documentation:
# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.express.doc%2Finfo%2Fexp%2Fae%2Ftxml_stopapplication.html

appManagerObject = AdminControl.queryNames('type=ApplicationManager,'
					   + 'cell=' + appserver_was_cell + ','
					   + 'node=' + appserver_was_node + ','
					   + 'process=' + appserver_was_serverInstance + ','
					   + '*')
#print appManagerObject
#print

print 'was-uninstall.py stopping ' + worklight_war_basename + '...'
try:
	AdminControl.invoke(appManagerObject, 'stopApplication', worklight_war_appname)
except:
	# Catch "com.ibm.ws.exception.RuntimeWarning: Application ... not started"
	pass
print 'was-uninstall.py stopping ' + worklight_war_basename + ' done'

print 'was-uninstall.py stopping ' + appcenter_war_basename + '...'
try:
	AdminControl.invoke(appManagerObject, 'stopApplication', appcenter_war_appname)
except:
	# Catch "com.ibm.ws.exception.RuntimeWarning: Application ... not started"
	pass
print 'was-uninstall.py stopping ' + appcenter_war_basename + ' done'


# ====================== Uninstall the web applications ======================

# Documentation:
# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.express.doc%2Finfo%2Fexp%2Fae%2Ftxml_uninstall.html

print 'was-uninstall.py uninstalling ' + worklight_war_basename + '...'
try:
	AdminApp.uninstall(worklight_war_appname)
except:
	# Catch "com.ibm.ws.scripting.ScriptingException: WASX7280E: An application with name ... does not exist."
	pass
print 'was-uninstall.py uninstalling ' + worklight_war_basename + ' done'

print 'was-uninstall.py uninstalling ' + appcenter_war_basename + '...'
try:
	AdminApp.uninstall(appcenter_war_appname)
except:
	# Catch "com.ibm.ws.scripting.ScriptingException: WASX7280E: An application with name ... does not exist."
	pass
print 'was-uninstall.py uninstalling ' + appcenter_war_basename + ' done'


# ========================== Delete the datasources ==========================

# Documentation:
# http://pic.dhe.ibm.com/infocenter/wasinfo/v8r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frxml_atjdbcprovider.html
# AdminTask.deleteDatasource was only introduced in WAS 8.0.

# Delete a datasource.
def deleteDatasource(jdbcProviderName, jdbcProviderObject, datasourceName):
	print 'was-uninstall.py deleting datasource...'
	datasourceObject = AdminConfig.getid(scopeContainmentPath + 'JDBCProvider:' + jdbcProviderName + '/DataSource:' + datasourceName + '/')
	if datasourceObject != '':
		AdminTask.deleteDatasource(datasourceObject)
	print 'was-uninstall.py deleting datasource done'

if was8:
	jdbcProviderName = 'Worklight JDBC Provider'
	jdbcProviderObject = AdminConfig.getid(scopeContainmentPath + 'JDBCProvider:' + jdbcProviderName + '/')
	if jdbcProviderObject != '':
		datasourceName = 'Worklight database'
		deleteDatasource(jdbcProviderName, jdbcProviderObject, datasourceName)
		datasourceName = 'Worklight reports database'
		deleteDatasource(jdbcProviderName, jdbcProviderObject, datasourceName)

	jdbcProviderName = 'Application Center JDBC Provider'
	jdbcProviderObject = AdminConfig.getid(scopeContainmentPath + 'JDBCProvider:' + jdbcProviderName + '/')
	if jdbcProviderObject != '':
		datasourceName = 'Application Center database'
		deleteDatasource(jdbcProviderName, jdbcProviderObject, datasourceName)


# ========================= Delete the JDBC providers =========================

# Documentation:
# http://pic.dhe.ibm.com/infocenter/wasinfo/v8r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frxml_atjdbcprovider.html
# AdminTask.deleteJDBCProvider was only introduced in WAS 8.0.

# Delete a JDBC provider.
def deleteJDBCProvider(jdbcProviderName):
	print 'was-uninstall.py deleting JDBC provider...'
	jdbcProviderObject = AdminConfig.getid(scopeContainmentPath + 'JDBCProvider:' + jdbcProviderName + '/')
	if jdbcProviderObject != '':
		AdminTask.deleteJDBCProvider(jdbcProviderObject)
	print 'was-uninstall.py deleting JDBC provider done'

if was8:
	jdbcProviderName = 'Worklight JDBC Provider'
	deleteJDBCProvider(jdbcProviderName)
	jdbcProviderName = 'Application Center JDBC Provider'
	deleteJDBCProvider(jdbcProviderName)


# ======================= Delete authentication aliases =======================

# Documentation:
# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.express.doc%2Finfo%2Fexp%2Fae%2Frxml_7securityconfig.html

print 'was-uninstall.py delete authentication alias...'
if not (database_selection == 'derby' or database_selection == 'mysql' or database_selection == 'oracle'):
	# By convention, alias names are displayed prefixed with the node.
	# But the prefix is not specified when it is created or looked up.
	authenticationAlias = 'Worklight' + database_selection.capitalize() + 'DatabaseCredentials'
	try:
		AdminTask.deleteAuthDataEntry(['-alias', authenticationAlias])
	except:
		# Note: This leaves an exception
		#   FFDC Exception:com.ibm.websphere.management.cmdframework.CommandValidationException
		#   SECJ7732E: The specified auth data entry does not exist.
		# in the server's log, but it can be ignored.
		pass
print 'was-uninstall.py delete authentication alias done'


# =========================== Delete user accounts ===========================

# Documentation:
# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.express.doc%2Finfo%2Fexp%2Fae%2Frxml_atwimmgt.html

if appserver_was_appcenteradmin_password != '':
	print 'was-uninstall.py delete appcenteradmin user...'
	try:
		AdminTask.deleteUser(['-uniqueName', 'uid=appcenteradmin,o=defaultWIMFileBasedRealm'])
	except:
		pass
	print 'was-uninstall.py delete appcenteradmin user done'


# ========================== Delete shared libraries ==========================

sharedLibraryName = 'Worklight Platform Library'
print 'was-uninstall.py delete shared library...'
sharedLibraryObject = AdminConfig.getid(scopeContainmentPath + 'Library:' + sharedLibraryName + '/')
if sharedLibraryObject != '':
	AdminConfig.remove(sharedLibraryObject)
print 'was-uninstall.py delete shared library done'


# ======================= Delete JVM system properties =======================

# How to do this?


# ==================================== Done ===================================

# Finally save all the changes.
AdminConfig.save()
